import 'package:freezed_annotation/freezed_annotation.dart';

part 'has_tash_model.freezed.dart';
part 'has_tash_model.g.dart';

@freezed
class HasTashModel with _$HasTashModel {
  factory HasTashModel({
    int? id,
    String? name,
    dynamic fullname,
    @JsonKey(name: 'custom_banner') dynamic customBanner,
    dynamic intro,
    @JsonKey(name: 'parent_id') dynamic parentId,
    dynamic order,
    String? level,
    dynamic group,
    dynamic lists,
    int? status,
    String? slug,
    @JsonKey(name: 'is_feature') dynamic isFeature,
    @JsonKey(name: 'collect_product') dynamic collectProduct,
    @JsonKey(name: 'collect_brand') dynamic collectBrand,
    @JsonKey(name: 'meta_title') dynamic metaTitle,
    @JsonKey(name: 'meta_keyword') dynamic metaKeyword,
    @JsonKey(name: 'meta_description') dynamic metaDescription,
    @JsonKey(name: 'is_home') dynamic isHome,
    int? deleted,
    @JsonKey(name: 'created_at') DateTime? createdAt,
    @JsonKey(name: 'updated_at') DateTime? updatedAt,
    @JsonKey(name: 'deleted_at') dynamic deletedAt,
    dynamic code,
    dynamic image,
  }) = _HasTashModel;

  factory HasTashModel.fromJson(Map<String, dynamic> json) =>
      _$HasTashModelFromJson(json);
}
