import 'package:sharing/remote/network/either.dart';
import 'package:sharing/remote/network/fetch_data.dart';
import 'package:sharing/remote/network/fetch_failure.dart';

import '../models/fcm_model/fcm_model.dart';
import '../params/device_params.dart';

abstract class AccountRepository {
  Future<Either<FetchFailure, FcmModel?>> sendCallNotification(
      {required String? id,
      required String? authen,
      required String? name,
      required String? phone,
      final String? email,
      final String? roomName,
      final String? roomId,
      List<String>? usersId,
      required List<String> usersToNotify});

  Future<void> signIn(
      {required String loginkey,
      required password,
      required deviceId,
      required Function(FetchData) funDataServer,
      required Function(FetchFailure) funError});

  Future<Either<FetchFailure, String?>> signOut();

  Future<void> call(
      {required String receiverId,
      required Function(FetchData) funDataServer,
      required Function(FetchFailure) funError});

  Future<void> getExpertList(
      {required Function(FetchData) funDataServer,
      required Function(FetchFailure) funError});

  Future<void> devices(
      {required DeviceParams params,
      required Function(FetchData) funDataServer,
      required Function(FetchFailure) funError});
}
