import 'package:bloc/bloc.dart';
import 'package:hainong_expert_module/core/data/local/shared_pref_source.dart';
import 'package:hainong_expert_module/core/data/service/account_repository.dart';
import 'package:injectable/injectable.dart';
import 'app_event.dart';
import 'app_state.dart';

final String serverToken =
    'AAAA19l1u44:APA91bFvIAl5YyuKIya5LDI2xPdkiFJKK7AwqTkPVRgqgr-AyYO6xoyjz4s-llRIk-fNc9ggZgLAIF1kFF1l3Etdd2l1XwXZgkCDaiA0X9x-5A9FFjrC3j65Swl_Y7kQaTC0WRCpxw3-';


@injectable
class AppBloc extends Bloc<AppEvent, AppState> {
  final AccountRepository accountRepository;
  final SharePrefSource sharePrefSource;

  AppBloc(this.accountRepository, this.sharePrefSource)
      : super(initAppState()) {
    on<Init>(_init);
    on<JoinRoomEvent>(onJoinRoom);
    on<SendCallNotificationEvent>(_onSendCallNotification);
  }

  _init(event, emit) {}

  onJoinRoom(JoinRoomEvent event, Emitter<AppState> emit) async {

  }

  _onSendCallNotification(SendCallNotificationEvent event, emit) async {
    final response = await accountRepository.sendCallNotification(
        id: event.id,
        authen: "key=${serverToken}",
        name: event.name,
        phone: event.phone,
        email: event.email,
        roomId: event.roomId,
        roomName: event.roomName,
        usersToNotify: event.usersToNotify!,
        usersId: event.usersId);
    if (response.get != null) {
      final result = response.get;
      return emit(SendCallSuccess(data: result));
    }
  }
}
