import 'package:flutter/material.dart';
import 'package:sharing/common/values/sizes.dart';
import 'package:sharing/widget/image/safe_image.dart';
import 'package:sharing/widget/text/custom_text_default_bold_field.dart';

class CustomSliverBasicBar extends StatefulWidget {
  final String? image;
  final String? title;
  final Widget body;

  const CustomSliverBasicBar(
      {Key? key, required this.image, required this.title, required this.body})
      : super(key: key);

  @override
  State<CustomSliverBasicBar> createState() => _CustomSliverBasicBarState();
}

class _CustomSliverBasicBarState extends State<CustomSliverBasicBar> {
  @override
  Widget build(BuildContext context) => Scaffold(
        body: CustomScrollView(
          slivers: [
            SliverAppBar(
              backgroundColor: Colors.red,
              expandedHeight: Sizes.HEIGHT_200,
              floating: true,
              pinned: true,
              flexibleSpace: FlexibleSpaceBar(
                background: SafeImage(imageUrl: widget.image),
                title: CustomTextDefaultBoldField(label: widget.title),
                centerTitle: true,
              ),
              leading: Icon(Icons.arrow_back),
              // actions: [
              //   Icon(Icons.settings),
              //   SizedBox(width: 12),
              // ],
            ),
            widget.body
          ],
        ),
      );
}
