import 'dart:async';
import 'package:flutter/material.dart';
import '../../../core/data/local/shared_pref_source.dart';
import '../../../core/data/models/user_model.dart';
import 'package:sharing/common/utils/enum/supported_locale.dart';

import '../../di/injector.dart';

mixin BaseHandleMixin<T extends StatefulWidget> on State<T> {
  bool? isNumberBadge = false;
  bool? isLoading = false;
  int? numberBadge = 0;
  int? invoiceId;
  UserModel? currentUser;
  SupportedLocale? locale = SupportedLocale.vi;
  StreamSubscription? appSubcription;

  @override
  void initState() {
    initData();
    super.initState();
  }

  @override
  void dispose() {
    appSubcription?.cancel();
    super.dispose();
  }

  void initData() async {
    setState(() {
      currentUser = getIt<SharePrefSource>().getUser();
    });
  }
}
