import 'package:dio/dio.dart';
import '../../../core/data/network/api_service_header_interceptor.dart';
import 'package:injectable/injectable.dart';
import 'package:pretty_dio_logger/pretty_dio_logger.dart';

@module
abstract class AppModule {
  // @Named('base_url')
  // String get baseUrl {
  //   return String.fromEnvironment('base_url',
  //       defaultValue: "https://api.stream.acecom.vn/publics");
  // }

  @lazySingleton
  @Named('base_dio')
  Dio dio(ApiServiceHeaderInterceptor headerInterceptor) {
    final Dio dio = Dio(BaseOptions(
      contentType: 'application/json',
      connectTimeout: 5000,
      sendTimeout: 5000,
    ));
    dio.interceptors.add(headerInterceptor);
    dio.interceptors.addAll([PrettyDioLogger()]);
    return dio;
  }

}
